package com.jpattern.orm.test;

import java.sql.ResultSet;

import com.jpattern.orm.IOrmPersistor;
import com.jpattern.orm.exception.OrmException;
import com.jpattern.orm.test.domain.Employee;

/**
 * 
 * @author Francesco Cina
 *
 * 22/mag/2011
 */
public class EmployeePersistor implements IOrmPersistor<Employee> {

	/**
	 * 
	 */
	

	@Override
	public Employee mapRow(String rowNamePrefix, ResultSet rs, int rowNum) {
		Employee employee = new Employee();
		try {
			employee.setId( rs.getLong(rowNamePrefix + "ID") );
			employee.setAge( rs.getInt(rowNamePrefix + "AGE") );
			employee.setEmployeeNumber( rs.getString(rowNamePrefix + "EMPLOYEE_NUMBER") );
			employee.setName( rs.getString(rowNamePrefix + "NAME") );
			employee.setSurname( rs.getString(rowNamePrefix + "SURNAME") );
		} catch (Exception e) {
			throw new OrmException(e);
		}
		return employee;
	}

	@Override
	public Object[] allValues(Employee entity) {
		Object[] result = new Object[]{entity.getId(), entity.getAge(), entity.getName(), entity.getSurname(), entity.getEmployeeNumber()}; 
		return result;
	}

	@Override
	public Object[] primaryKeyValues(Employee entity) {
		Object[] result = new Object[]{entity.getId()}; 
		return result;
	}

	@Override
	public Object[] notPrimaryKeyValues(Employee entity) {
		Object[] result = new Object[]{ entity.getAge(), entity.getName(), entity.getSurname(), entity.getEmployeeNumber()}; 
		return result;
	}

	@Override
	public void updatePrimaryKey(ResultSet rs, Employee entity) {
		try {
			entity.setId( rs.getLong(0) );
			entity.setAge( rs.getInt("AGE") );
		} catch (Exception e) {
			throw new OrmException(e);
		}
	}

	@Override
	public Object[] allNotGeneratedValues(Employee entity) {
		Object[] result = new Object[]{entity.getId(), entity.getAge(), entity.getName(), entity.getSurname(), entity.getEmployeeNumber()}; 
		return result;
	}

}
