package com.jpattern.orm.test;

import java.util.Date;

import com.jpattern.orm.BaseTest;
import com.jpattern.orm.IJPOrm;
import com.jpattern.orm.session.ISession;
import com.jpattern.orm.transaction.ITransaction;
import com.jpattern.orm.test.domain.Employee;

/**
 * 
 * @author Francesco Cina
 *
 * 20/mag/2011
 */
public class EmployeeTest extends BaseTest {

	protected void setUp() throws Exception {
		super.setUp();
	}

	protected void tearDown() throws Exception {
		super.tearDown();
	}
	
	
	public void testCrudEmployee() throws Exception {
		IJPOrm jpOrm =getJPOrm();
		
		jpOrm.register(Employee.class);
		
        long id = new Date().getTime();
		Employee employee = new Employee();
		employee.setId( id );
		employee.setAge( 44 );
		employee.setEmployeeNumber( ("" + id).substring(0, 9) );
		employee.setName("Wizard");
		employee.setSurname("Cina");
		
		// CREATE
        ISession conn = jpOrm.session();
        ITransaction tx = conn.getTransaction();
        conn.save(employee);
        tx.commit();
        
        // LOAD
        tx = conn.getTransaction();
        Employee employeeLoad1 = conn.find(Employee.class, new Object[]{id});
        assertNotNull(employeeLoad1);
        assertEquals( employee.getId(), employeeLoad1.getId() );
        assertEquals( employee.getName(), employeeLoad1.getName() );
        assertEquals( employee.getSurname(), employeeLoad1.getSurname() );
        assertEquals( employee.getEmployeeNumber(), employeeLoad1.getEmployeeNumber() );
        
        //UPDATE
        employeeLoad1.setName("Wizard");
        conn.update(employeeLoad1);
        tx.commit();
        
        // LOAD
        tx = conn.getTransaction();
        Employee employeeLoad2 = conn.find(Employee.class, new Object[]{id});
        assertNotNull(employeeLoad2);
        assertEquals( employeeLoad1.getId(), employeeLoad2.getId() );
        assertEquals( employeeLoad1.getName(), employeeLoad2.getName() );
        assertEquals( employeeLoad1.getSurname(), employeeLoad2.getSurname() );
        assertEquals( employeeLoad1.getEmployeeNumber(), employeeLoad2.getEmployeeNumber() );
        
        //DELETE
        conn.delete(employeeLoad2);
        Employee employeeLoad3 = conn.find(Employee.class, new Object[]{id});
        assertNull(employeeLoad3);
        tx.commit();
        
	}

}
