package com.jpattern.orm.test.h2;

import java.io.InputStream;
import java.io.Reader;
import java.util.Date;

import com.jpattern.orm.BaseTest;
import com.jpattern.orm.IJPOrm;
import com.jpattern.orm.test.domain.Blobclob_Stream;
import com.jpattern.orm.util.OrmUtil;
import com.jpattern.orm.session.ISession;
import com.jpattern.orm.transaction.ITransaction;

/**
 * 
 * @author Francesco Cina
 *
 * 20/mag/2011
 */
public class BlobClob_InputStream_Reader_Test extends BaseTest {

	protected void setUp() throws Exception {
		super.setUp();
	}

	protected void tearDown() throws Exception {
		super.tearDown();
	}
	
	public void testCrudBlobclob() throws Exception {
		IJPOrm jpOrm =getJPOrm();
		
		jpOrm.register(Blobclob_Stream.class);
		
        long id = new Date().getTime();
        
        String text1 = "BINARY STRING TEST 1 " + id;
		InputStream is1 = OrmUtil.convertStringToStream(text1, OrmUtil.UTF8);

		String text2 = "BINARY STRING TEST 2 " + id;
        Reader reader2 = OrmUtil.convertStringToReader(text2);
		
		Blobclob_Stream blobclob = new Blobclob_Stream();
		blobclob.setBlobInputStream(is1);
		blobclob.setClob(reader2);
		
		// CREATE
        ISession conn = jpOrm.session();
        ITransaction tx = conn.getTransaction();
        conn.save(blobclob);
        tx.commit();
        
        reader2.close();
        is1.close();
        
        System.out.println("Blobclob saved with id: " + blobclob.getId());
        assertFalse( id == blobclob.getId() );
        id = blobclob.getId();
        
        // LOAD
        tx = conn.getTransaction();
        Blobclob_Stream blobclobLoad1 = conn.find(Blobclob_Stream.class, new Object[]{id});
        assertNotNull(blobclobLoad1);
        assertEquals( blobclob.getId(), blobclobLoad1.getId() );
        
        String retrieved1 = OrmUtil.convertStreamToString( blobclobLoad1.getBlobInputStream(), OrmUtil.UTF8, false);
        System.out.println("Retrieved1 String " + retrieved1);
        assertEquals( text1 , retrieved1 );
        
        String retrieved2 = OrmUtil.convertReaderToString( blobclobLoad1.getClob(), false);
        System.out.println("Retrieved2 String " + retrieved2);
        assertEquals( text2 , retrieved2 );
        
        //DELETE
        conn.delete(blobclobLoad1);
        Blobclob_Stream blobclobLoad2 = conn.find(Blobclob_Stream.class, new Object[]{id});
        assertNull(blobclobLoad2);
        tx.commit();
        
	}

}
